base-4.6.0.1: Basic libraries

Portability | non-portable (uses Text.ParserCombinators.ReadP)
Stability | provisional
Maintainer | libraries@haskell.org
Safe Haskell | Trustworthy

Text.Read.Lex

Description

The cut-down Haskell lexer, used by Text.Read

Synopsis

- data Lexeme
  - = Char Char
  - | String String
  - | Punc String
  - | Ident String
  - | Symbol String
  - | Number Number
  - | EOF
- numberToInteger :: Number -> Maybe Integer
- numberToRational :: Number -> Rational
- numberToRangedRational :: (Int, Int) -> Number -> Maybe Rational
- lex :: ReadP Lexeme
- hsLex :: ReadP String
- lexChar :: ReadP Char
- readIntP :: Num a => a -> (Char -> Bool) -> (Char -> Int) -> ReadP a
- readOctP :: (Eq a, Num a) => ReadP a
- readDecP :: (Eq a, Num a) => ReadP a
- readHexP :: (Eq a, Num a) => ReadP a

# Documentation

data Lexeme

Haskell lexemes.

Constructors

Char Char | Character literal
String String | String literal, with escapes interpreted
Punc String | Punctuation or reserved symbol, e.g. `(`, `::`
Ident String | Haskell identifier, e.g. `foo`, `Baz`
Symbol String | Haskell symbol, e.g. `>>`, `:%`
Number Number |
EOF |

Instances

Eq Lexeme |
Read Lexeme |
Show Lexeme |

numberToInteger :: Number -> Maybe Integer

numberToRational :: Number -> Rational

numberToRangedRational :: (Int, Int) -> Number -> Maybe Rational

lex :: ReadP Lexeme

hsLex :: ReadP String

Haskell lexer: returns the lexed string, rather than the lexeme

lexChar :: ReadP Char

readIntP :: Num a => a -> (Char -> Bool) -> (Char -> Int) -> ReadP a

readOctP :: (Eq a, Num a) => ReadP a

readDecP :: (Eq a, Num a) => ReadP a

readHexP :: (Eq a, Num a) => ReadP a